"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.signatureMemberReturns = void 0;
const elements_1 = require("../../../support/elements");
/**
 * @category Partials
 */
function signatureMemberReturns(context, signature, headingLevel) {
    var _a, _b, _c;
    const md = [];
    const typeDeclaration = (_a = signature.type) === null || _a === void 0 ? void 0 : _a.declaration;
    const showReturns = ((_b = signature.comment) === null || _b === void 0 ? void 0 : _b.blockTags.length) ||
        (typeDeclaration === null || typeDeclaration === void 0 ? void 0 : typeDeclaration.signatures) ||
        (typeDeclaration === null || typeDeclaration === void 0 ? void 0 : typeDeclaration.children);
    if (showReturns) {
        md.push((0, elements_1.heading)(headingLevel, 'Returns'));
        if ((_c = signature.comment) === null || _c === void 0 ? void 0 : _c.blockTags.length) {
            const tags = signature.comment.blockTags
                .filter((tag) => tag.tag === '@returns')
                .map((tag) => context.commentParts(tag.content));
            md.push(tags.join('\n\n'));
        }
        if (typeDeclaration === null || typeDeclaration === void 0 ? void 0 : typeDeclaration.signatures) {
            typeDeclaration.signatures.forEach((signature) => {
                md.push((0, elements_1.blockQuoteBlock)(context.signatureMember(signature, headingLevel + 1)));
            });
        }
        if (typeDeclaration === null || typeDeclaration === void 0 ? void 0 : typeDeclaration.children) {
            md.push((0, elements_1.blockQuoteBlock)(context.typeDeclarationMember(typeDeclaration, headingLevel)));
        }
    }
    return md.join('\n\n');
}
exports.signatureMemberReturns = signatureMemberReturns;
