"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pageTitle = void 0;
const typedoc_1 = require("typedoc");
const helpers_1 = require("../../helpers");
/**
 * @category Partials
 */
function pageTitle(context, page) {
    var _a;
    const titleTemplate = context.options.getValue('titleTemplate');
    const name = (0, helpers_1.getMemberTitle)(page.model);
    if (((_a = page.model) === null || _a === void 0 ? void 0 : _a.url) === page.project.url) {
        return 'API';
    }
    return titleTemplate
        .replace('{name}', name)
        .replace('{kind}', typedoc_1.ReflectionKind.singularString(page.model.kind));
}
exports.pageTitle = pageTitle;
