import { DeclarationReflection, ProjectReflection, TypeDocOptions } from 'typedoc';
import { UrlMapping } from '../plugin/url-mapping';
import { NavigationItem, UrlOption } from '../theme/models';
import { MarkdownTheme } from './theme';
export declare class UrlsContext {
    theme: MarkdownTheme;
    options: Partial<TypeDocOptions>;
    urls: UrlMapping[];
    navigation: NavigationItem[];
    anchors: Record<string, string[]>;
    constructor(theme: MarkdownTheme, options: Partial<TypeDocOptions>);
    /**
     * Map the models of the given project to the desired output files.
     * Based on TypeDoc DefaultTheme.getUrls()
     *
     * @param project  The project whose urls should be generated.
     */
    getUrls(project: ProjectReflection): UrlMapping[];
    /**
     *
     * @param project
     * @param isPackage
     */
    private buildUrlsFromProject;
    private buildUrlsFromGroup;
    getUrl(reflection: DeclarationReflection, options: UrlOption): string;
    private applyAnchorUrl;
    private getAnchorId;
    private getAnchorName;
    private childrenIncludeNamespaces;
}
